100 '****************************************************************'
110 '*                         K E Y B                              *'
120 '*--------------------------------------------------------------*'
130 '*  Task           : makes a subroutine available which         *'
140 '*                   reads a character from the keyboard. The   *'
150 '*                   status of the control keys                 *'
160 '*                   (INSERT, CAPS, NUM) are displayed          *'
170 '*                   on the screen                              *'
180 '*  Author         : MICHAEL TISCHER                            *'
190 '*  developed on   : 7.22.87                                    *'
200 '*  last Update    : 9.21.87                                    *'
210 '****************************************************************'
220 '
230 CLS : KEY OFF
240 PRINT"WARNING: This Program can only be started if GWBASIC was "
250 PRINT"started from the DOS level with <GWBASIC  /m60000>."
260 PRINT : PRINT"If this is not the case, please input <s> for Stop."
270 PRINT"Else press any key...";
280 A$ = INKEY$ : IF A$ = "s" THEN END
290 IF A$ = "" THEN 280
300 GOSUB 60000              'install function for Interrupt call 
310 CLS                                              'Clear Screen 
320 PRINT"TAST (c) 1987 by Michael Tischer" : PRINT
330 PRINT"You can input some characters and change the status of the NUM,"
340 PRINT"CAPS and INSERT mode, where every change is documented in "
350 PRINT"the upper right corner of the display."
360 PRINT"The input of <RETURN> terminates the Program..." : PRINT
370 PRINT"Your Input: ";
380 GOSUB 50000                 'initialize keyboard-Flags 
390 GOSUB 51000                 'read a character 
400 IF LEN(Z$) = 2 THEN 390     'on extended Code do nothing 
410 PRINT Z$;                   'output characters 
420 IF ASC(Z$) <> 13 THEN 390   'on RETURN terminate 
430 PRINT
440 END
450 '
50000 '************************************************************'
50010 '* initialize keyboard-Flags                                *'
50020 '*----------------------------------------------------------*'
50030 '* Input: none                                              *'
50040 '* Output: none                                             *'
50050 '* Info   : the Variable Z% is used as a Dummy              *'
50060 '*          the Status of the keyboard Flags is stored in   *'
50070 '*          variables INSERT%, CAPS% and NUM%               *'
50080 '************************************************************'
50090 '
50100 FKT%=2                   'get function number for keyboard status 
50110 INR%=&H16                'call BIOS-keyboard-Interrupt 16(h) 
50120 CALL IA(INR%,FKT%,FLAGS%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
50130 IF FLAGS% AND 128 THEN INSERT% = 0 ELSE INSERT% = -1
50140 IF FLAGS% AND 64 THEN CAPS% = 0 ELSE CAPS% = -1
50150 IF FLAGS% AND 32 THEN NUM% = 0 ELSE NUM% = -1
50160 RETURN                   'back to caller 
50170 '
51000 '***************************************************************'
51010 '* get a character from the keyboard and maybe output          *'
51020 '* Flag-Status                                                 *'
51030 '*-------------------------------------------------------------*'
51040 '* Input: none                                                 *'
51050 '* Output: Z$ = the character read                             *'
51060 '* Info   : the Variable Z% is used as Dummy                   *'
51070 '*          if Z$ is two character long, an extended           *'
51080 '*          keyboard code was input. The first character of the*'
51090 '*          string is in such a case the NUL-character,        *'
51100 '*          and the second character indicates the Code of the *'
51110 '*          extended key                                       *'
51120 '**************************************************************'
51130 '
51140 FKT%=2                 'get function number for keyboard status 
51150 INR%=&H16              'call BIOS-keyboard-Interrupt 16(h) 
51160 CALL IA(INR%,FKT%,FLAGS%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
51170 IF INSERT% = ((FLAGS% AND 128) = 128) THEN 51230
51180 INSERT% = NOT INSERT%  'Insert-Status has changed 
51190 COLMN% = 75            'Column for Insert-Text
51200 FLAG% = INSERT%        'Status of Insert-Flags
51210 FTEXT$ = "INSERT"      'Flag-Text
51220 GOSUB 52000            'output Flag-Text 
51230 IF CAPS% = ((FLAGS% AND 64) = 64) THEN 51290
51240 CAPS% = NOT CAPS%      'Caps-Status has changed 
51250 COLMN% = 69            'Column for Caps-Text
51260 FLAG% = CAPS%          'Status of Caps-Flag
51270 FTEXT$ = " CAPS "      'Flag-Text
51280 GOSUB 52000            'output Flag-Text 
51290 IF NUM% = ((FLAGS% AND 32) = 32) THEN 51350
51300 NUM% = NOT NUM%        'Num-Status has changed 
51310 COLMN% = 66            'Column for Num-Text
51320 FLAG% = NUM%           'Status of Num-Flag
51330 FTEXT$ = "NUM"         'Flag-Text
51340 GOSUB 52000            'output Flag-Text 
51350 FKT%=1                 'test function number for characters 
51360 INR%=&H16              'call BIOS-keyboard-Interrupt 16(h) 
51370 CALL IA(INR%,FKT%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,FLAGREG%)
51380 IF (FLAGREG% AND 64) = 64 THEN 51140'no key --> get Flags 
51390 Z$ = INKEY$
51400 RETURN                 'back to caller 
51410 '
52000 '**************************************************************'
52010 '* Set Cursor Position                                        *'
52020 '*------------------------------------------------------------*'
52030 '* Input: FLAG%   = Status of Flags either on or off          *'
52040 '*          FTEXT$  = Flag-Text                               *'
52050 '*          COLMN% = is the new column for Cursor             *'
52060 '*          CLINE%  = is the new line for Cursor              *'
52070 '* Output: none                                               *'
52080 '* Info   : the Variable Z% is used as a Dummy                *'
52090 '**************************************************************'
52100 '
52110 CURCLINE% = CSRLIN-1               'record current Cursor line 
52120 CURCOLMN% = POS(0)-1               'record current Cursor column 
52130 LOCATE 1,COLMN%                    'Cursor position for Flag-Text
52140 IF FLAG% THEN COLOR 0,7 ELSE COLOR 0,0
52150 PRINT FTEXT$
52160 LOCATE CURCLINE%+1,CURCOLMN%+1     'set old Cursor position 
52170 FKT%=2                  'set function number for Cursor position 
52180 INR%=&H10               'call BIOS-Video-Interrupt 10(h) 
52190 SEITE% = 0              'set Cursor in display page 0 
52200 CALL IA(INR%,FKT%,Z%,SEITE%,Z%,Z%,Z%,CURCLINE%, CURCOLMN%,Z%,Z%,Z%,Z%)
52210 COLOR 7,0
52220 RETURN                  'back to caller 
52230 '
60000 '***************************************************************'
60010 '* initialize the Routine for Interrupt-call                   *'
60020 '*-------------------------------------------------------------*'
60030 '* Input: none                                                 *'
60040 '* Output: IA is the Start address of the Interrupt-Routine    *'
60050 '***************************************************************'
60060 '
60070 IA=60000!      'Start address of the Routine in the BASIC-Segment
60080 DEF SEG        'set BASIC-Segment 
60090 RESTORE 60130
60100 FOR I% = 0 TO 160 : READ X% : POKE IA+I%,X% : NEXT  'poke Routine 
60110 RETURN         'back to caller 
60120 '
60130 DATA  85,139,236, 30,  6,139,118, 30,139,  4,232,140,  0,139,118
60140 DATA  12,139, 60,139,118,  8,139,  4, 61,255,255,117,  2,140,216
60150 DATA 142,192,139,118, 28,138, 36,139,118, 26,138,  4,139,118, 24
60160 DATA 138, 60,139,118, 22,138, 28,139,118, 20,138, 44,139,118, 18
60170 DATA 138, 12,139,118, 16,138, 52,139,118, 14,138, 20,139,118, 10
60180 DATA 139, 52, 85,205, 33, 93, 86,156,139,118, 12,137, 60,139,118
60190 DATA  28,136, 36,139,118, 26,136,  4,139,118, 24,136, 60,139,118
60200 DATA  22,136, 28,139,118, 20,136, 44,139,118, 18,136, 12,139,118
60210 DATA  16,136, 52,139,118, 14,136, 20,139,118,  8,140,192,137,  4
60220 DATA  88,139,118,  6,137,  4, 88,139,118, 10,137,  4,  7, 31, 93
60230 DATA 202, 26,  0, 91, 46,136, 71, 66,233,108,255
