100 '*****************************************************************'
110 '*                          M O V E                              *'
120 '*---------------------------------------------------------------*'
130 '*  Task         : uses the Routine for moving a storage area    *'
140 '*                 to store the Video-RAM                        *'
150 '*  Author       : MICHAEL TISCHER                               *'
160 '*  developed on : 7.22.87                                       *'
170 '*  last Update  : 9.21.87                                       *'
180 '*****************************************************************'
190 '
200 CLS : KEY OFF
210 PRINT"WARNING: This program can only be started if the GWBASIC "
220 PRINT"was started from the DOS level with <GWBASIC  /m60000>"
230 PRINT : PRINT"If this is not the case, input an <s> to Stop "
240 PRINT"Else, press any key...";
250 A$ = INKEY$ : IF A$ = "s" THEN END
260 IF A$ = "" THEN 250
270 CLS                                              'Clear Screen 
280 PRINT"MOVE (c) 1987 by Michael Tischer" : PRINT
290 PRINT"This Program uses Function 87(h) of Interrupt 15(h) to copy blocks "
300 PRINT"of memory between the 'normal' RAM and the RAM beyond the "
310 PRINT"1-Megabyte border."
320 DEF SEG = &HF000                                'Set BIOS-segment 
330 IF PEEK(&HFFFE) = &HFC THEN 380                        'test if AT
340 PRINT"Since this unit is not an AT, but a PC or "
350 PRINT"XT, and they do not have storage beyond the 1-MB limit, "
360 PRINT"this program can not be executed! Sorry..."
370 END                                 'Terminate Program (PC or XT)
380 PRINT"The Program will first copy the current display immediately beyond the "
390 PRINT"1 MB border and will then clear the screen. If you then press a key, "
400 PRINT"the old screen content will be restored."
410 PRINT : PRINT"Please activate a key to start the program...";
420 A$ = INKEY$ : IF A$ = "" THEN 420                  'wait for key 
430 STARTS% = VIDEOS% : STARTO% = 0     'Start-area is Video-RAM:0000
440 GOSUB 60000                  'install Function for Interrupt call 
450 GOSUB 61000                  'install Function for copying memory 
460 GOSUB 50000                               'get current Video mode 
470 IF VMODE% = 7 THEN VIDEOS% = &HB000 ELSE VIDEOS% = &HB800
480 STARTO% = 0 : STARTS% = VIDEOS%   'Start address  is the Video-RAM
490 DESTS% = 0 : DESTO% = 0           'destination area is 10000:0000
500 DIRECTION% = 1                    'copy from below to above 1 MB 
510 SIZE% = 2000             'the size of the Video-RAM is 200 Words 
520 GOSUB 51000                        'move memory 
530 CLS                                'clear screen 
540 PRINT"Please activate a key  ..."
550 A$ = INKEY$ : IF A$ = "" THEN 550                  'wait for key 
560 STARTS% = 0 : STARTO% = 0       'Start area is 10000:0000
570 DESTS% = VIDEOS% : DESTO% = 0   'Destination area is Video-RAM:0000
580 DIRECTION% = 2                  'copy from above to below 1 MB 
590 GOSUB 51000                     'move memory 
600 LOCATE 15,1                     'Set Cursor to column 1 of line 15 
610 END
620 '
50000 '**************************************************************'
50010 '* Sense current Video Mode                                   *'
50020 '*------------------------------------------------------------*'
50030 '* Input: none                                                *'
50040 '* Output: VMODE% = the current Video mode                    *'
50050 '* Info   : the Variable Z% is used as Dummy                  *'
50060 '**************************************************************'
50070 Z%=15                        'get Function number for Video mode 
50080 INR%=&H10                    'call BIOS-Video-Interrupt 16(h) 
50090 CALL IA(INR%,Z%,VMODE%,PAGE%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%,Z%)
50100 RETURN                       'back to caller 
50110 '
51000 '**************************************************************'
51010 '* move a memory area                                         *'
51020 '*------------------------------------------------------------*'
51030 '* Input: STARTS%   = segment address of the Start area       *' 
51040 '*        STARTO%   = Offset address of the Start area        *'
51050 '*        DESTS%    = segment address of the destination area *'
51060 '*        DESTO%    = Offset address of the destination area  *'
51070 '*        SIZE%     = Number of words to be moved             *'
51080 '*       DIRECTION% = Direction in which to move              *'
51090 '*                  data:                                     *'
51100 '*                     0 = from below 1 MB --> to below 1 MB  *'
51110 '*                     1 = from below 1 MB --> beyond 1 MB    *'
51120 '*                     2 = from above 1 MB --> below 1 MB     *'
51130 '*                     3 = from beyond 1 MB --> beyond 1 MB   *'
51140 '* Output: none                                               *'
51150 '**************************************************************'
51160 CALL MOVE(STARTS%,STARTO%,DESTS%,DESTO%,SIZE%,DIRECTION%)
51170 RETURN                                        'back to caller 
51180 '
60000 '*************************************************************'
60010 '* initialize the Routine for Interrupt call                 *'
60020 '*-----------------------------------------------------------*'
60030 '* Input: none                                               *'
60040 '* Output: IA is the Start address of the Interrupt-Routine  *'
60050 '************************************************************'
60060 '
60070 IA=60000!      'Start address of the Routine in the BASIC-segment
60080 DEF SEG        'Set BASIC-segment 
60090 RESTORE 60130
60100 FOR I% = 0 TO 160 : READ X% : POKE IA+I%,X% : NEXT  'poke Routine 
60110 RETURN                                        'back to caller 
60120 '
60130 DATA  85,139,236, 30,  6,139,118, 30,139,  4,232,140,  0,139,118
60140 DATA  12,139, 60,139,118,  8,139,  4, 61,255,255,117,  2,140,216
60150 DATA 142,192,139,118, 28,138, 36,139,118, 26,138,  4,139,118, 24
60160 DATA 138, 60,139,118, 22,138, 28,139,118, 20,138, 44,139,118, 18
60170 DATA 138, 12,139,118, 16,138, 52,139,118, 14,138, 20,139,118, 10
60180 DATA 139, 52, 85,205, 33, 93, 86,156,139,118, 12,137, 60,139,118
60190 DATA  28,136, 36,139,118, 26,136,  4,139,118, 24,136, 60,139,118
60200 DATA  22,136, 28,139,118, 20,136, 44,139,118, 18,136, 12,139,118
60210 DATA  16,136, 52,139,118, 14,136, 20,139,118,  8,140,192,137,  4
60220 DATA  88,139,118,  6,137,  4, 88,139,118, 10,137,  4,  7, 31, 93
60230 DATA 202, 26,  0, 91, 46,136, 71, 66,233,108,255
60240 '
61000 '***************************************************************'
61010 '* Initialize Routine for moving of mremory areas.             *'
61020 '*-------------------------------------------------------------*'
61030 '* Input: none                                                 *'
61040 '* Output: MOVE is the Start address of the Routine            *'
61050 '***************************************************************'
61060 '
61070 DEF SEG                            'Set BASIC segment 
61080 MOVE=61000!                        'Start address of the Routine
61090 RESTORE 61130
61100 FOR I% = 0 TO 140: READ BYTE% : POKE MOVE+I%,BYTE% : NEXT
61110 RETURN                             'back to caller 
61120 '
61130 DATA 232,115,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
61140 DATA   0,  0,  0,  0,255,255,  0,  0, 16,146,  0,  0,255,255,  0
61150 DATA   0,  0,146,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
61160 DATA   0,  0,  0,  0,  0,  0, 85,139,236,139,126,  6,138, 45,139
61170 DATA 126, 12,139,  5,139,126, 10,139, 29,246,197,  1,232, 46,  0
61180 DATA 136, 84, 28,137, 68, 26,139,126, 16,139,  5,139,126, 14,139
61190 DATA  29,246,197,  2,232, 24,  0,136, 84, 20,137, 68, 18,180,135
61200 DATA 139,126,  8,139, 13,205, 21,139,229, 93,202, 12,  0, 94,235
61210 DATA 186,138,212,177,  4,210,234,117,  3,128,202, 16,211,224,  3
61220 DATA 195,115,  2,254,194,195
