100 '*****************************************************************'
110 '*                         R A W C O O K                         *'
120 '*---------------------------------------------------------------*'
130 '*  Task        : make two subroutines available                 *'
140 '*                to switch the character driver into RAW- or    *'
150 '*                COOKED mode                                    *'
160 '*  Author      : MICHAEL TISCHER                                *'
170 '*  developed   : 07/23/87                                       *'
180 '*  last Update : 04/08/89                                       *'
190 '*****************************************************************'
200 '
210 CLS : KEY OFF
220 PRINT"WARNING: This program can only be started if the GWBASIC was"
230 PRINT"started from DOS with the command <GWBASIC  /m60000>."
240 PRINT : PRINT"If this is not the case, please input <s> for Stop."
250 PRINT"Otherwise press any key...";
260 A$ = INKEY$ : IF A$ = "s" THEN END
270 IF A$ = "" THEN 260
280 GOSUB 60000                    'Install function for interrupt call
290 CLS                                                  'erase display
300 HANDLE% = 0                'handle is connected with console driver
310 PRINT"RAWCOOK (c) 1987 by Michael Tischer" : PRINT
320 PRINT"The Console driver (Keyboard and Display) is now in RAW-"
330 PRINT"Mode so that during input and output no control characters "
335 PRINT"are recognized."
340 PRINT"Because of this not even <CTRL> + <S> can stop the "
345 PRINT"following output."
350 PRINT"Try it ..." : PRINT
360 PRINT "Press any key to start output ..."
365 GOSUB 25000                                  'Clear keyboard buffer
370 A$ = INKEY$ : IF A$ = "" THEN 370                   'wait for a key
380 GOSUB 52000                    'Switch console driver into RAW mode
390 GOSUB 50000                                     'Output Test-String
400 CLS
410 PRINT"The Console driver (Keyboard and Display) is now in "
420 PRINT"COOKED mode. Control characters will be recognized during "
425 PRINT"input/output."
430 PRINT"The following output can be stopped with <CTRL> + <S>."
440 PRINT"Try it ..." : PRINT
450 PRINT "Press any key to start the output..."
455 GOSUB 25000                              'Clear the keyboard buffer
460 A$ = INKEY$ : IF A$ = "" THEN 460                   'wait for a key
470 GOSUB 51000               'change console driver to the COOKED mode
480 GOSUB 50000                                     'output Test-String
490 CLS
500 END
510 '
25000 A$ = INKEY$ : IF A$ = "" THEN RETURN   'Clear the keyboard buffer
25010 goto 25000
50000 '***************************************************************'
50010 '* outputs a Test-String on the Standard output device         *'
50020 '*-------------------------------------------------------------*'
50030 '* Input : none                                                *'
50040 '* Output: none                                                *'
50050 '***************************************************************'
50060 '
50070 T$ = "Test.... "                              'Output Test-String
50080 FOR I = 1 TO 250                                       '250 times
50090 FCT% = &H40 : FCT1% = 0         'Write function number for handle
50100 INR% = &H21                             'Call DOS-Interrupt 21(h)
50110 ADRLO% = 9 : ADRHI% = 0            'output 9 characters at a time
50120 OFSLO% = PEEK(VARPTR(T$)+1)  'LO-byte of offset address of string
50130 OFSHI% = PEEK(VARPTR(T$)+2)     'HI-byte of offset address string
50140 HANDLO% = 1: HANDHI% = 0      'address the standard output device 
50150 CALL IA(INR%,FCT%,FCT1%,HANDHI%,HANDLO%,ADRHI%,ADRLO%,OFSHI%,OFSLO%,Z%,Z%,Z%,Z%)
50160 NEXT                                                    'next run
50170 PRINT
50180 RETURN                                            'back to caller
50190 '
51000 '***************************************************************'
51010 '* change device driver to COOKED mode                         *'
51020 '*-------------------------------------------------------------*'
51030 '* Input : HANDLE% = handle connected with the driver          *'
51040 '* Output: none                                                *'
51050 '***************************************************************'
51060 '
51070 GOSUB 53000                       'Get device attribute of driver
51080 ATTRIB% = ATTRIB% AND 223                        'Find COOKED-Bit
51090 GOSUB 54000                       'Set device attribute of driver
51100 RETURN                                            'back to caller
51110 '
52000 '***************************************************************'
52010 '* change device driver to RAW mode                            *'
52020 '*-------------------------------------------------------------*'
52030 '* Input : HANDLE% = handle connected to the driver            *'
52040 '* Output: none                                                *'
52050 '***************************************************************'
52060 '
52070 GOSUB 53000                       'Get device attribute of driver
52080 ATTRIB% = ATTRIB% OR 32                              'Set RAW-Bit
52090 GOSUB 54000                       'Set device attribute of driver
52100 RETURN                                            'back to caller
52110 '
53000 '***************************************************************'
53010 '* Get device attribute of a driver                            *'
53020 '*-------------------------------------------------------------*'
53030 '* Input : HANDLE% = handle connected with a driver            *'
53040 '* Output: ATTRIB% = Attribute of driver                       *'
53050 '* Info  : Z% used as Dummy-Variable                           *'
53060 '*         only Bits 0 to 7 of the device attribute            *'
53070 '*         determined                                          *'
53080 '***************************************************************'
53090 '
53100 FCT%=&H44                              'Function number for IOCTL
53110 FCT1%=0    'Read Function number for IOCTL: Read device attribute
53120 INR%=&H21                               'Call DOS-Interrupt 21(h)
53130 HANDHI% = INT(HANDLE%/256)                 'HI-byte of the handle
53140 HANDLO% = HANDLE% AND 255                  'LO-byte of the handle
53150 CALL IA(INR%,FCT%,FCT1%,HANDHI%,HANDLO%,Z%,Z%,Z%,ATTRIB%,Z%,Z%,Z%,Z%)
53160 RETURN                                            'back to caller
53170 '
54000 '***************************************************************'
54010 '* Set device attribute of a driver                            *'
54020 '*-------------------------------------------------------------*'
54030 '* Input : HANDLE% = handle connected to a driver              *'
54040 '*         ATTRIB% = the attribute of the driver               *'
54050 '* Output: none                                                *'
54060 '* Info  : Z% used as Dummy-Variable                           *'
54070 '***************************************************************'
54080 '
54090 FCT%=&H44                              'Function number for IOCTL
54100 FCT1%=1          'Set function number for IOCTL: device attribute
54110 INR%=&H21                               'Call DOS-Interrupt 21(h)
54120 HANDHI% = INT(HANDLE%/256)                 'HI-byte of the handle
54130 HANDLO% = HANDLE% AND 255                  'LO-byte of the handle
54140 ATHI% = INT(ATTRIB%/256)                'HI-byte of the Attribute
54150 ATLO% = ATTRIB% AND 255                 'LO-byte of the Attribute
54160 CALL IA(INR%,FCT%,FCT1%,HANDHI%,HANDLO%,Z%,Z%,ATHI%,ATLO%,Z%,Z%,Z%,Z%)
54170 RETURN                                            'back to caller
54180 '
60000 '***************************************************************'
60010 '* Initialize the Routine for Interrupt Call                   *'
60020 '*-------------------------------------------------------------*'
60030 '* Input : none                                                *'
60040 '* Output: IA is the Start address of the Interrupt-Routine    *'
60050 '***************************************************************'
60060 '
60070 IA=60000!      'Start address of the routine in the BASIC-Segment
60080 DEF SEG                                        'Set BASIC-Segment
60090 RESTORE 60130
60100 FOR I% = 0 TO 160 : READ X% : POKE IA+I%,X% : NEXT  'Poke Routine 
60110 RETURN                                            'back to caller
60120 '
60130 DATA  85,139,236, 30,  6,139,118, 30,139,  4,232,140,  0,139,118
60140 DATA  12,139, 60,139,118,  8,139,  4, 61,255,255,117,  2,140,216
60150 DATA 142,192,139,118, 28,138, 36,139,118, 26,138,  4,139,118, 24
60160 DATA 138, 60,139,118, 22,138, 28,139,118, 20,138, 44,139,118, 18
60170 DATA 138, 12,139,118, 16,138, 52,139,118, 14,138, 20,139,118, 10
60180 DATA 139, 52, 85,205, 33, 93, 86,156,139,118, 12,137, 60,139,118
60190 DATA  28,136, 36,139,118, 26,136,  4,139,118, 24,136, 60,139,118
60200 DATA  22,136, 28,139,118, 20,136, 44,139,118, 18,136, 12,139,118
60210 DATA  16,136, 52,139,118, 14,136, 20,139,118,  8,140,192,137,  4
60220 DATA  88,139,118,  6,137,  4, 88,139,118, 10,137,  4,  7, 31, 93
60230 DATA 202, 26,  0, 91, 46,136, 71, 66,233,108,255
